
package de.ivu.elect.business.system.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.system.entity.SystemLog;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractSystemLogEdit {

  @Inject
  protected SystemLogDAO dao;

  @Inject
  protected SystemLogExtendedDAO extendedDao;

  public void delete(SystemLog entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(SystemLog entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(SystemLog entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected SystemLog getAttachedEntity(SystemLog entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected SystemLog getAttachedAndRefreshedEntity(SystemLog entity) {
    return dao.refresh(entity);
  }
}
